%ifndef LOADER
%assign RMCALL_VECT     RMCALL_VECT+1
%assign N_DSC           N_DSC-2         ; Loader allocates 2 descriptors
%assign N_INT           N_INT-1         ; Loader sets 1 interrupt gate

code32sel       dw      0
data32sel       dw      0
zerosel         dw      0
code16sel       dw      0
data16sel       dw      0
pspsel          dw      0
envsel          dw      0

IRQ0_vect       db      0
IRQ1_vect       db      0
IRQ2_vect       db      0
IRQ3_vect       db      0
IRQ4_vect       db      0
IRQ5_vect       db      0
IRQ6_vect       db      0
IRQ7_vect       db      0
IRQ8_vect       db      0
IRQ9_vect       db      0
IRQ10_vect      db      0
IRQ11_vect      db      0
IRQ12_vect      db      0
IRQ13_vect      db      0
IRQ14_vect      db      0
IRQ15_vect      db      0

v86r_edi:
v86r_di         dw      0
                dw      0
v86r_esi:
v86r_si         dw      0
                dw      0
v86r_ebp:
v86r_bp         dw      0
                dw      0
                dd      0
v86r_ebx:
v86r_bx:
v86r_bl         db      0
v86r_bh         db      0
                dw      0
v86r_edx:
v86r_dx:
v86r_dl         db      0
v86r_dh         db      0
                dw      0
v86r_ecx:
v86r_cx:
v86r_cl         db      0
v86r_ch         db      0
                dw      0
v86r_eax:
v86r_ax:
v86r_al         db      0
v86r_ah         db      0
                dw      0
v86r_flags      dw      0
v86r_es         dw      0
v86r_ds         dw      0
v86r_fs         dw      0
v86r_gs         dw      0
v86r_ip         dw      0
v86r_cs         dw      0
v86r_sp         dw      0
v86r_ss         dw      0

code16a         dd      0
code32a         dd      0
lomembase       dd      0
lomemtop        dd      0
himembase       dd      0
himemtop        dd      0
totalextmem     dd      0
hextbl          db      '0123456789ABCDEF'
windows         db      0
returncode      db      0
systemtype      db      0

exit            dd      0
                dw      0
getmem          dd      0
                dw      0
getlomem        dd      0
                dw      0
gethimem        dd      0
                dw      0
lomemsize       dd      0
                dw      0
himemsize       dd      0
                dw      0
getdsc          dd      0
                dw      0
setdsc          dd      0
                dw      0
getvect         dd      0
                dw      0
setvect         dd      0
                dw      0
map_phys_addr   dd      0
                dw      0
dosshell        dd      0
                dw      0
dosprint        dd      0
                dw      0
putstr          dd      0
                dw      0

%else

SELSTART        equ     0
code32selOFF    equ     SELSTART
data32selOFF    equ     SELSTART+2
zeroselOFF      equ     SELSTART+4
code16selOFF    equ     SELSTART+6
data16selOFF    equ     SELSTART+8
pspselOFF       equ     SELSTART+10
envselOFF       equ     SELSTART+12

IRQSTART        equ     14
IRQ0_vectOFF    equ     IRQSTART
IRQ1_vectOFF    equ     IRQSTART+1
IRQ2_vectOFF    equ     IRQSTART+2
IRQ3_vectOFF    equ     IRQSTART+3
IRQ4_vectOFF    equ     IRQSTART+4
IRQ5_vectOFF    equ     IRQSTART+5
IRQ6_vectOFF    equ     IRQSTART+6
IRQ7_vectOFF    equ     IRQSTART+7
IRQ8_vectOFF    equ     IRQSTART+8
IRQ9_vectOFF    equ     IRQSTART+9
IRQ10_vectOFF   equ     IRQSTART+10
IRQ11_vectOFF   equ     IRQSTART+11
IRQ12_vectOFF   equ     IRQSTART+12
IRQ13_vectOFF   equ     IRQSTART+13
IRQ14_vectOFF   equ     IRQSTART+14
IRQ15_vectOFF   equ     IRQSTART+15

REGSTRUCOFF     equ     30

MISCSTART       equ     80
code16aOFF      equ     MISCSTART
code32aOFF      equ     MISCSTART+4
lomembaseOFF    equ     MISCSTART+8
lomemtopOFF     equ     MISCSTART+12
himembaseOFF    equ     MISCSTART+16
himemtopOFF     equ     MISCSTART+20
totalextmemOFF  equ     MISCSTART+24
hextblOFF       equ     MISCSTART+28
windowsOFF      equ     MISCSTART+44
returncodeOFF   equ     MISCSTART+45
systemtypeOFF   equ     MISCSTART+46

FUNCSTART       equ     127
exitOFF         equ     FUNCSTART
getmemOFF       equ     FUNCSTART+6
getlomemOFF     equ     FUNCSTART+12
gethimemOFF     equ     FUNCSTART+18
lomemsizeOFF    equ     FUNCSTART+24
himemsizeOFF    equ     FUNCSTART+30
getdscOFF       equ     FUNCSTART+36
setdscOFF       equ     FUNCSTART+42
getvectOFF      equ     FUNCSTART+48
setvectOFF      equ     FUNCSTART+54
map_phys_addrOFF equ    FUNCSTART+60
dosshellOFF     equ     FUNCSTART+66
dosprintOFF     equ     FUNCSTART+72
putstrOFF       equ     FUNCSTART+78

%endif
