; This program is made by Daniel Horchner.
; email: Daniel.Horchner@95.Student.WAU.NL
;        dbjh@usa.net

        .386p
        locals
        jumps

code32  segment para public use32
        assume cs:code32, ds:code32, ss:code32

NO_EXTERN       =       0       ; 'extrn' directives must not be included
include ..\raw32.inc
include raw32mod.inc

;32-bit data
msg             db      'Hello, world! From above 1MB!',0
dosmsg          db      'This message is printed via DOS.',13,10,'$'

;32-bit code
main:
        db 1024*1024 dup(90h)           ; Dummy NOP instr -> >640KB code!

        mov esi,offset msg
        mov es,data32sel
        @rlp edi,0b8000h+160
        mov bl,1fh
        call putstr

        mov edx,offset dosmsg
        call dosprintx

        mov esi,0
;        call dosshell

@exit:
        mov v86r_ah,0                   ; ah=0 -> Wait for key and read char
        mov al,16h
        int RMCALL_VECT
        mov returncode,2
        jmp exit                        ; Return to real/V86 mode

;
; Put number in eax to es:edi in ASCII hexadecimal
; In:
;   eax = number
; Out:
;   edi = 1 byte past last written character
;
putnum:
        push eax ebx ecx edx
        mov edx,eax
        mov ebx,offset hextbl
        mov ecx,8
        mov ah,0fh
@@next_digit:
        rol edx,4
        mov al,dl
        and al,0fh
        xlat
        stosw
        loop @@next_digit
        pop edx ecx ebx eax
        ret

;
; Print '$' terminated string via DOS
; In:
;   ds = data32sel
;   edx = offset of string
;
; Note:
;   This is just a test if dosprint can be called. Since the address of the
;   string must be in low memory for dosprint, this routine first copies the
;   string pointed to by edx to a buffer in low memory before calling
;   dosprint.
;
dosprintx:
        push eax ecx esi edi es
        mov ax,ds                       ; First, get string length
        mov es,ax                       ; es=ds for scasb
        mov edi,edx
        mov ecx,0ffffffffh              ; Search max 4GB
        mov al,'$'                      ; Scan for '$' (=end of DOS string)
        cld
        repne scasb                     ; Compare al with es:edi
        not ecx
        mov eax,ecx                     ; ecx=string length (including '$')
        push lomembase
        call getlomem
        mov esi,edx
        mov edi,eax
        cld
        rep movsb
        mov edx,eax
        call dosprint
        pop lomembase
        pop es edi esi ecx eax
        ret

code32  ends
        end     main
