ifndef LOADER
RMCALL_VECT     =       RMCALL_VECT+1
N_DSC           =       N_DSC-2         ; Loader allocates 2 descriptors
N_INT           =       N_INT-1         ; Loader sets 1 interrupt gate

code32sel       dw      0
data32sel       dw      0
zerosel         dw      0
code16sel       dw      0
data16sel       dw      0
pspsel          dw      0
envsel          dw      0

IRQ0_vect       db      0
IRQ1_vect       db      0
IRQ2_vect       db      0
IRQ3_vect       db      0
IRQ4_vect       db      0
IRQ5_vect       db      0
IRQ6_vect       db      0
IRQ7_vect       db      0
IRQ8_vect       db      0
IRQ9_vect       db      0
IRQ10_vect      db      0
IRQ11_vect      db      0
IRQ12_vect      db      0
IRQ13_vect      db      0
IRQ14_vect      db      0
IRQ15_vect      db      0

v86r_edi        label   dword
v86r_di         dw      0
                dw      0
v86r_esi        label   dword
v86r_si         dw      0
                dw      0
v86r_ebp        label   dword
v86r_bp         dw      0
                dw      0
                dd      0
v86r_ebx        label   dword
v86r_bx         label   word
v86r_bl         db      0
v86r_bh         db      0
                dw      0
v86r_edx        label   dword
v86r_dx         label   word
v86r_dl         db      0
v86r_dh         db      0
                dw      0
v86r_ecx        label   dword
v86r_cx         label   word
v86r_cl         db      0
v86r_ch         db      0
                dw      0
v86r_eax        label   dword
v86r_ax         label   word
v86r_al         db      0
v86r_ah         db      0
                dw      0
v86r_flags      dw      0
v86r_es         dw      0
v86r_ds         dw      0
v86r_fs         dw      0
v86r_gs         dw      0
v86r_ip         dw      0
v86r_cs         dw      0
v86r_sp         dw      0
v86r_ss         dw      0

code16a         dd      0
code32a         dd      0
lomembase       dd      0
lomemtop        dd      0
himembase       dd      0
himemtop        dd      0
totalextmem     dd      0
hextbl          db      '0123456789ABCDEF'
windows         db      0
returncode      db      0
systemtype      db      0

exit            label   fword
                dd      0
                dw      0
getmem          label   fword
                dd      0
                dw      0
getlomem        label   fword
                dd      0
                dw      0
gethimem        label   fword
                dd      0
                dw      0
lomemsize       label   fword
                dd      0
                dw      0
himemsize       label   fword
                dd      0
                dw      0
getdsc          label   fword
                dd      0
                dw      0
setdsc          label   fword
                dd      0
                dw      0
getvect         label   fword
                dd      0
                dw      0
setvect         label   fword
                dd      0
                dw      0
map_phys_addr   label   fword
                dd      0
                dw      0
dosshell        label   fword
                dd      0
                dw      0
dosprint        label   fword
                dd      0
                dw      0
putstr          label   fword
                dd      0
                dw      0

else

SELSTART        =       0
code32selOFF    =       SELSTART
data32selOFF    =       SELSTART+2
zeroselOFF      =       SELSTART+4
code16selOFF    =       SELSTART+6
data16selOFF    =       SELSTART+8
pspselOFF       =       SELSTART+10
envselOFF       =       SELSTART+12

IRQSTART        =       14
IRQ0_vectOFF    =       IRQSTART
IRQ1_vectOFF    =       IRQSTART+1
IRQ2_vectOFF    =       IRQSTART+2
IRQ3_vectOFF    =       IRQSTART+3
IRQ4_vectOFF    =       IRQSTART+4
IRQ5_vectOFF    =       IRQSTART+5
IRQ6_vectOFF    =       IRQSTART+6
IRQ7_vectOFF    =       IRQSTART+7
IRQ8_vectOFF    =       IRQSTART+8
IRQ9_vectOFF    =       IRQSTART+9
IRQ10_vectOFF   =       IRQSTART+10
IRQ11_vectOFF   =       IRQSTART+11
IRQ12_vectOFF   =       IRQSTART+12
IRQ13_vectOFF   =       IRQSTART+13
IRQ14_vectOFF   =       IRQSTART+14
IRQ15_vectOFF   =       IRQSTART+15

REGSTRUCOFF     =       30

MISCSTART       =       80
code16aOFF      =       MISCSTART
code32aOFF      =       MISCSTART+4
lomembaseOFF    =       MISCSTART+8
lomemtopOFF     =       MISCSTART+12
himembaseOFF    =       MISCSTART+16
himemtopOFF     =       MISCSTART+20
totalextmemOFF  =       MISCSTART+24
hextblOFF       =       MISCSTART+28
windowsOFF      =       MISCSTART+44
returncodeOFF   =       MISCSTART+45
systemtypeOFF   =       MISCSTART+46

FUNCSTART       =       127
exitOFF         =       FUNCSTART
getmemOFF       =       FUNCSTART+6
getlomemOFF     =       FUNCSTART+12
gethimemOFF     =       FUNCSTART+18
lomemsizeOFF    =       FUNCSTART+24
himemsizeOFF    =       FUNCSTART+30
getdscOFF       =       FUNCSTART+36
setdscOFF       =       FUNCSTART+42
getvectOFF      =       FUNCSTART+48
setvectOFF      =       FUNCSTART+54
map_phys_addrOFF=       FUNCSTART+60
dosshellOFF     =       FUNCSTART+66
dosprintOFF     =       FUNCSTART+72
putstrOFF       =       FUNCSTART+78

endif
